#!/usr/bin/perl -w

@palettedata = (
((0,0,0,0),(0,0,128,0),(0,128,0,0),(0,128,128,0),(128,0,0,0),(128,0,128,0) 
,(128,64,0,0),(128,128,128,0),(64,64,64,0),(0,0,255,0),(0,255,0,0) 
,(0,255,255,0),(255,0,0,0),(255,0,255,0),(255,255,0,0),(255,255,255,0)),
((0,0,0,0),(0,0,255,0),(0,255,0,0),(0,255,255,0),(255,0,0,0),(255,0,255,0) 
,(255,128,0,0),(196,196,196,0),(128,128,128,0),(128,128,255,0),(128,255,128,0) 
,(128,255,255,0),(255,128,128,0),(255,128,255,0),(255,255,128,0),(255,255,255,0)),
((0,0,0,0),(0,128,0,0),(128,0,0,0),(128,64,0,0),(0,0,128,0),(0,128,128,0) 
,(128,0,128,0),(128,128,128,0),(64,64,64,0),(0,255,0,0),(255,0,0,0) 
,(255,255,0,0),(0,0,255,0),(0,255,255,0),(255,0,255,0),(255,255,255,0)),
((0,0,0,0),(0,255,0,0),(255,0,0,0),(255,128,0,0),(0,0,255,0),(0,255,255,0) 
,(255,0,255,0),(196,196,196,0),(128,128,128,0),(128,255,128,0),(255,128,128,0) 
,(255,255,128,0),(128,128,255,0),(128,255,255,0),(255,128,255,0),(255,255,255,0)));



$extended_colour = $firstext = (( @palettedata + 0 ) / 4 ) + 128 ;
$ext = '' ;
%extended_colour_set = ( ) ;


@filelist = ( "vgazero480" , "vgaemerald" , "vgaemeraldmask" , "vgasbag" , "vgasbagmask" ,
	"vgarbag" , "vgarbagmask" , "vgalbag" , "vgalbagmask" , "vgafbag" , "vgafbagmask" ,
	"vgagold1" , "vgagold1mask" , "vgagold2" , "vgagold2mask" , "vgagold3" , 
	"vgagold3mask" , "vganobbin3" , "vganobbin3mask" , "vganobbin2" , "vganobbin2mask" , 
	"vganobbin1" , "vganobbin1mask" , "vganobbind" , "vganobbindmask" , "vgarhobbin1" , 
	"vgarhobbin1mask" , "vgarhobbin2" , "vgarhobbin2mask" , "vgarhobbin3" , 
	"vgarhobbin3mask" , "vgarhobbind" ,
	"vgarhobbindmask" , "vgalhobbin1" , "vgalhobbin1mask" , "vgalhobbin2" ,
	"vgalhobbin2mask" , "vgalhobbin3" , "vgalhobbin3mask" , "vgalhobbind" , 
	"vgalhobbindmask" , "vgabonus" , "vgabonusmask" , "vgardigger3" ,
	"vgardigger3mask" , "vgarxdigger3" , "vgarxdigger3mask" , "vgardigger2" ,
	"vgardigger2mask" , "vgarxdigger2" , "vgarxdigger2mask" , "vgardigger1" ,
	"vgardigger1mask" , "vgarxdigger1" , "vgarxdigger1mask" , "vgaldigger3" ,
	"vgaldigger3mask" , "vgalxdigger3" , "vgalxdigger3mask" , "vgaldigger2" ,
	"vgaldigger2mask" , "vgalxdigger2" , "vgalxdigger2mask" , "vgaldigger1" ,
	"vgaldigger1mask" , "vgalxdigger1" , "vgalxdigger1mask" , "vgaudigger3" ,
	"vgaudigger3mask" , "vgauxdigger3" , "vgauxdigger3mask" , "vgaudigger2" ,
	"vgaudigger2mask" , "vgauxdigger2" , "vgauxdigger2mask" , "vgaudigger1" ,
	"vgaudigger1mask" , "vgauxdigger1" , "vgauxdigger1mask" , "vgaddigger3" ,
	"vgaddigger3mask" , "vgadxdigger3" , "vgadxdigger3mask" , "vgaddigger2" ,
	"vgaddigger2mask" , "vgadxdigger2" , "vgadxdigger2mask" , "vgaddigger1" ,
	"vgaddigger1mask" , "vgadxdigger1" , "vgadxdigger1mask" , "vgarbigger3" ,
	"vgarbigger3mask" , "vgarxbigger3" , "vgarxbigger3mask" , "vgarbigger2" ,
	"vgarbigger2mask" , "vgarxbigger2" , "vgarxbigger2mask" , "vgarbigger1" ,
	"vgarbigger1mask" , "vgarxbigger1" , "vgarxbigger1mask" , "vgalbigger3" ,
	"vgalbigger3mask" , "vgalxbigger3" , "vgalxbigger3mask" , "vgalbigger2" ,
	"vgalbigger2mask" , "vgalxbigger2" , "vgalxbigger2mask" , "vgalbigger1" ,
	"vgalbigger1mask" , "vgalxbigger1" , "vgalxbigger1mask" , "vgaubigger3" ,
	"vgaubigger3mask" , "vgauxbigger3" , "vgauxbigger3mask" , "vgaubigger2" ,
	"vgaubigger2mask" , "vgauxbigger2" , "vgauxbigger2mask" , "vgaubigger1" ,
	"vgaubigger1mask" , "vgauxbigger1" , "vgauxbigger1mask" , "vgadbigger3" ,
	"vgadbigger3mask" , "vgadxbigger3" , "vgadxbigger3mask" , "vgadbigger2" ,
	"vgadbigger2mask" , "vgadxbigger2" , "vgadxbigger2mask" , "vgadbigger1" ,
	"vgadbigger1mask" , "vgadxbigger1" , "vgadxbigger1mask" , "vgagrave5" ,
	"vgagrave5mask" , "vgagrave4" , "vgagrave4mask" , "vgagrave3" ,
	"vgagrave3mask" , "vgagrave2" , "vgagrave2mask" , "vgagrave1" ,
	"vgagrave1mask" , "vgadiggerd" , "vgadiggerdmask" , "vgabiggerd" ,
	"vgabiggerdmask" , "vgaliferight" , "vgaliferightmask" , "vgalifeleft" ,
	"vgalifeleftmask" , "vgaelife" , "vgaelifemask" , "vgaleftlife" ,
	"vgaleftlifemask" , "vgarightblobmask" , "vgaleftblobmask" , "vgatopblobmask" ,
	"vgabottomblobmask" , "vgafurryblobmask" , "vgasquareblobmask" , "vgaediggermask" ,
	"vgaback1" , "vgaback2" , "vgaback3" , "vgaback4" ,
	"vgaback5" , "vgaback6" , "vgaback7" , "vgaback8" ,
	"vgafire1" , "vgafire1mask" , "vgafire2" , "vgafire2mask" ,
	"vgafire3" , "vgafire3mask" , "vgaexp1" , "vgaexp1mask" ,
	"vgaexp2" , "vgaexp2mask" , "vgaexp3" , "vgaexp3mask" ,
	"vgafire1b" , "vgafire1bmask" , "vgafire2b" , "vgafire2bmask" ,
	"vgafire3b" , "vgafire3bmask" , "vgaexp1b" , "vgaexp1bmask" ,
	"vgaexp2b" , "vgaexp2bmask" , "vgaexp3b" , "vgaexp3bmask" ,
	"vgaemerald0" , "vgaemerald1" , "vgaemerald2" , "vgaemerald3" ,
	"vgaemerald4" , "vgaemerald5" , "vgaemerald6" , "vgaemerald7" ,
	"vgaemerald4mask" , "vgaemerald5mask" , "vgaemerald6mask" , 
	"vgaemerald7mask" ,
	"vgafire1left" , "vgafire1leftmask" ,
	"vgafire2left" , "vgafire2leftmask" ,
	"vgafire3left" , "vgafire3leftmask" ,
	"vgafire1up" , "vgafire1upmask" ,
	"vgafire2up" , "vgafire2upmask" ,
	"vgafire3up" , "vgafire3upmask" ,
	"vgafire1down" , "vgafire1downmask" ,
	"vgafire2down" , "vgafire2downmask" ,
	"vgafire3down" , "vgafire3downmask" ) ;


system 'cat xpm/header' ;


foreach $base ( @filelist )
{
	$filename = 'xpm/' . $base . '.xpm' ;
	$maskmode = 0 ;

	# special mask hack
	if ( $base =~ /mask$/ )
	{
		$try = $filename ;
		$try =~ s/mask\.xpm$/\.xpm/ ;

		if ( open XPM , $try )
		{
			close XPM ;
			$maskmode = 1 ;
			$filename = $try ;
		} 
	}

	open XPM , $filename or die "not found: " . $filename . "\n" ;

	print STDERR "file = " . $filename . "\n" ;

	$l = <XPM> ;
	$l = <XPM> ;
	if ( ! ( $l =~ /static char/ ))
	{
		die "not valid: " . $filename . "\n" ;
	}
	while (( $l = <XPM> )
	&& ( defined $l )
	&& ( 2 != (( $height , $colours ) = 
			$l =~ /^.\d+ (\d+) (\d+) .*$/ )))
	{
	}
	if ( ! defined $l )
	{
		die "not valid (2): " . $filename . "\n" ;
	}
	for ( $i = 0 ; $i < $colours ; $i ++ )
	{
		$l = <XPM> ;
		( $char , $colour ) = $l =~ /^"(.)\s+[cs]\s+(.*)",$/ ;
		$id{ $char } = -1 ;

		# mogrify colour corrections
		if ( $colour =~ /#[0-9a-f]{12}/ )
		{
			$colour =~ s/#([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})/#$1$3$5/ ;
		}
		if ( 1 == (( $greylevel ) = $colour =~ /gray(\d+)/ ))
		{
			$greylevel = int (( $greylevel * 255 ) / 100 ) ;
			$greylevel = sprintf "%02x%02x%02x" , $greylevel ,
					$greylevel , $greylevel ;
			$colour =~ s/gray\d+/#$greylevel/ ;
		}
		
		if ( $colour =~ /(none|background)/i )
		{
			$id{ $char } = 0xff ;
		} elsif ( $colour =~ /black/i )
		{
			$id{ $char } = 0 ;
		} elsif (( ! $maskmode )
		&& ( 3 == (( $r , $g , $b ) = $colour =~
				/#([0-9a-f][0-9a-f])([0-9a-f][0-9a-f])([0-9a-f][0-9a-f])/i )))
		{
			$r = hex $r ;
			$g = hex $g ;
			$b = hex $b ;
			if (( $r == 128 ) && ( $g == 128 ) && ( $b == 0 ))
			{
				$g = 64 ;	# hack
			}
			for ( $n = 0 ; $n < 256 ; $n += 4 )
			{
				if (( $r == $palettedata[ $n + 0 ] )
				&& ( $g == $palettedata[ $n + 1 ] )
				&& ( $b == $palettedata[ $n + 2 ] ))
				{
					$id{ $char } = $n / 4 ;
					last ;
				}
			}
			if ( $id{ $char } == -1 )
			{
				$str = sprintf "{ 0x%02x , 0x%02x , 0x%02x , 0 } ,\n" ,
					$r , $g , $b ;

				if ( defined $extended_colour_set{ $str } )
				{
					$id{ $char } = $extended_colour_set{ $str } ;
					print STDERR "reuse ext colour for " . $r . " " .
						$g . " " . $b . "\n" ;
				} else {
					$extended_colour_set{ $str } = $extended_colour ;
					$ext .= $str ;
					$id{ $char } = $extended_colour ;
					$extended_colour ++ ;
					if ( $extended_colour > 255 )
					{
						die "Too many extended colours\n" ;
					} else {
						print STDERR "add ext colour for " . $r . " " .
							$g . " " . $b . "\n" ;
					}
				}
			}
		} elsif ( $maskmode )
		{
			$id{ $char } = 0 ;
		} else {
			die "Unrecognised line: " . $l . "\ncolour: " . $colour . "\n" ;
		}
	}
	printf "Uint3 " . $base . "[]=%c\n" , 0x7b ;
	for ( $i = 0 ; $i < $height ; $i ++ )
	{
		$l = <XPM> ;
		while ( $l =~ / pixels / )
		{
			$l = <XPM> ;
			if ( ! defined ( $l ))
			{
				die "Weird comment.\n" ;
			}
		}

		chomp $l ;
		$l =~ s/^"(.+)"(,|};|)$/$1/ ;

		print "  " ;
		$comma = '' ;
		foreach $p ( split // , $l )
		{
			if ( ! defined $id{ $p } )
			{
				$pi = ord $p ;
				die "Pixel not found: " . $p . " (" . $pi . ")\n" .
					"line: " . $l . "\n" ;
			}
			printf "%s0x%02x" , $comma , $id{ $p } ;
			$comma = ',' ;
		}
		if ( $height == ( $i + 1 ))
		{
			printf "%c;\n\n" , 0x7d ;
		} else {
			print ",\n" ;
		}
	}
	close XPM ;
}


system 'cat xpm/footer' ;

printf "\n\n#include <SDL.h>\n" .
	"int extended_palette_first = %d ;\n" .
	"int extended_palette_size = %d ;\n" .
	"SDL_Color extended_palette[] = {\n%s} ;\n\n" , 
		$firstext , ( $extended_colour - $firstext ) , $ext ;

print STDERR "file conversion ok. ext pal size = " .
		( $extended_colour - $firstext ) . "\n" ;




